// Copyright (c) The Phobos Authors
// SPDX-License-Identifier: MPL-2.0
// Copyright (c) HashiCorp, Inc.
// SPDX-License-Identifier: MPL-2.0

package plugin

import (
	"bytes"
	"fmt"
	"io"
	"path/filepath"
	"strings"
	"text/template"

	"golang.org/x/text/cases"
	"golang.org/x/text/language"

	"gitlab.com/infor-cloud/martian-cloud/phobos/phobos-plugin-docs/internal/mdplain"
	"gitlab.com/infor-cloud/martian-cloud/phobos/phobos-plugin-docs/internal/tmplfuncs"
	"gitlab.com/infor-cloud/martian-cloud/phobos/phobos-plugin-docs/schemamd"
	"gitlab.com/infor-cloud/martian-cloud/phobos/phobos-plugin-sdk/internal-shared/component"
	"gitlab.com/infor-cloud/martian-cloud/phobos/phobos-plugin-sdk/internal-shared/schema"
)

const (
	schemaComment = "<!-- schema generated by phobosplugindocs -->"

	frontmatterComment = "# generated by https://gitlab.com/infor-cloud/martian-cloud/phobos/phobos-plugin-docs"
)

type (
	actionTemplate string
	pluginTemplate string

	docTemplate string
)

func newTemplate(pluginDir, name, text string) (*template.Template, error) {
	tmpl := template.New(name)
	titleCaser := cases.Title(language.Und)

	tmpl.Funcs(map[string]interface{}{
		"codefile":      codeFile(pluginDir),
		"lower":         strings.ToLower,
		"plainmarkdown": mdplain.PlainMarkdown,
		"prefixlines":   tmplfuncs.PrefixLines,
		"split":         strings.Split,
		"hclfile":       hclCodeFile(pluginDir),
		"title":         titleCaser.String,
		"trimspace":     strings.TrimSpace,
		"upper":         strings.ToUpper,
	})

	var err error
	tmpl, err = tmpl.Parse(text)
	if err != nil {
		return nil, fmt.Errorf("unable to parse template %q: %w", text, err)
	}

	return tmpl, nil
}

func codeFile(pluginDir string) func(string, string) (string, error) {
	return func(format string, file string) (string, error) {
		if filepath.IsAbs(file) {
			return tmplfuncs.CodeFile(format, file)
		}

		return tmplfuncs.CodeFile(format, filepath.Join(pluginDir, file))
	}
}

func hclCodeFile(pluginDir string) func(string) (string, error) {
	return func(file string) (string, error) {
		if filepath.IsAbs(file) {
			return tmplfuncs.CodeFile("hcl", file)
		}

		return tmplfuncs.CodeFile("hcl", filepath.Join(pluginDir, file))
	}
}

func renderTemplate(pluginDir, name string, text string, out io.Writer, data interface{}) error {
	tmpl, err := newTemplate(pluginDir, name, text)
	if err != nil {
		return err
	}

	err = tmpl.Execute(out, data)
	if err != nil {
		return fmt.Errorf("unable to execute template: %w", err)
	}

	return nil
}

func renderStringTemplate(pluginDir, name, text string, data interface{}) (string, error) {
	var buf bytes.Buffer

	err := renderTemplate(pluginDir, name, text, &buf, data)
	if err != nil {
		return "", err
	}

	return buf.String(), nil
}

func (t docTemplate) Render(pluginDir string, out io.Writer) error {
	s := string(t)
	if s == "" {
		return nil
	}

	return renderTemplate(pluginDir, "docTemplate", s, out, nil)
}

func (t pluginTemplate) Render(pluginDir, exampleFile, pluginName string, pluginSchema *schema.PluginSchema) (string, error) {
	schemaBuffer := bytes.NewBuffer(nil)
	err := schemamd.RenderPlugin(pluginSchema, schemaBuffer)
	if err != nil {
		return "", fmt.Errorf("unable to render schema: %w", err)
	}

	s := string(t)
	if s == "" {
		return "", nil
	}

	return renderStringTemplate(pluginDir, "pluginTemplate", s, struct {
		Description string

		HasExample  bool
		ExampleFile string

		PluginName      string
		PluginShortName string
		SchemaMarkdown  string
	}{
		Description: pluginSchema.Description,

		HasExample:  exampleFile != "" && fileExists(exampleFile),
		ExampleFile: exampleFile,

		PluginName:      pluginName,
		PluginShortName: pluginShortName(pluginName),

		SchemaMarkdown: schemaComment + "\n" + schemaBuffer.String(),
	})
}

func (t actionTemplate) Render(pluginDir, name, typeName, exampleFile, pluginName string, schema *component.PipelinePluginActionSchema) (string, error) {
	schemaBuffer := bytes.NewBuffer(nil)
	err := schemamd.RenderAction(schema, schemaBuffer)
	if err != nil {
		return "", fmt.Errorf("unable to render schema: %w", err)
	}

	s := string(t)
	if s == "" {
		return "", nil
	}

	return renderStringTemplate(pluginDir, "actionTemplate", s, struct {
		Type        string
		Name        string
		Group       string
		Description string

		HasExample  bool
		ExampleFile string

		PluginName      string
		PluginShortName string

		SchemaMarkdown string
	}{
		Type:        typeName,
		Name:        name,
		Group:       schema.Group,
		Description: schema.Description,

		HasExample:  exampleFile != "" && fileExists(exampleFile),
		ExampleFile: exampleFile,

		PluginName:      pluginName,
		PluginShortName: pluginShortName(pluginName),

		SchemaMarkdown: schemaComment + "\n" + schemaBuffer.String(),
	})
}

const defaultActionTemplate actionTemplate = `---
` + frontmatterComment + `
page_title: "{{.Name}} {{.Type}} - {{.PluginName}}"
subcategory: "{{.Group}}"
description: |-
{{ .Description | plainmarkdown | trimspace | prefixlines "  " }}
---

# {{.Name}} ({{.Type}})

{{ .Description | trimspace }}

{{ if .HasExample -}}
## Example Usage

{{hclfile .ExampleFile }}
{{- end }}

{{ .SchemaMarkdown | trimspace }}
`

const defaultPluginTemplate pluginTemplate = `---
` + frontmatterComment + `
page_title: "{{.PluginShortName}} Plugin"
subcategory: ""
description: |-
{{ .Description | plainmarkdown | trimspace | prefixlines "  " }}
---

# {{.PluginShortName}} Plugin

{{ .Description | trimspace }}

{{ if .HasExample -}}
## Example Usage

{{hclfile .ExampleFile }}
{{- end }}

{{ .SchemaMarkdown | trimspace }}
`
